---
# https://nghttp2.org/documentation/h2load-howto.html

- name: Testing | git clone h2load repository
  ansible.builtin.git:
    repo: https://github.com/nghttp2/nghttp2.git
    dest: /var/tmp/nghttp2
    version: "{{ h2load_gitrev | default(omit) }}"
    update: false

- name: Testing | ensure h2load dependencies are present
  ansible.builtin.package:
    name: "{{ item }}"
    state: present
  with_items: "{{ testing_h2load_deps }}"
  register: pkg_result
  until: pkg_result is success

- name: Testing | build h2load
  ansible.builtin.command: "{{ item }}"
  with_items:
    - git submodule update --init
    - autoreconf -i
    - automake
    - autoconf
    - ./configure
    - make
    - make install
  args:
    chdir: /var/tmp/nghttp2
    creates: /usr/local/bin/h2load
  environment: "{{ h2load_env | default(omit) }}"
  notify:
    - Run ldconfig

- name: Testing | executing h2load
  ansible.builtin.shell: |
    set -o pipefail
    h2load -n100000 -c100 -m10 {{ testing_target }} | tee /tmp/h2load.log
  args:
    executable: /bin/bash
    creates: /tmp/h2load.log
  environment:
    PATH: /usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin
